rand('seed', getdate('s'))
rand('uniform')

function y=simul1_binomiale(n,p)
    y=0;
    for k=1:n
        if (rand()<p) then y=y+1;
        end
    end
endfunction

function y=simul2_binomiale(n,p)
    y=sum(rand(1,n)<p);
endfunction

function y=distrib_binomiale(n,p)
    y=zeros(1,n+1);
    // ci-dessous on met à jour le vecteur y pour que y(1,k) contienne P(X=k-1) pour 1<=k<=n+1
    y(1)=(1-p)^n;
    for k=1:n
        // P(X=k)=(n-k+1)/k*p/(1-p)*P(X=k-1)
        y(k+1)=(n-k+1)/k*p/(1-p)*y(k);
    end
endfunction

N=10^4;     // nombre de simulations
n0=20;      // choix des paramètres
p0=.25;     // choix des paramètres
x=0:n0;     // vecteur des valeurs possibles pour X

// Version classique : 
// S=zeros(1,N)    // initialisation du vecteur des résultats
// for k=1:N
//    S(k)=simul_binomiale(n0,p0);
//end

// Version matricielle : 
S=sum(rand(N,n0)<p0,'c')

[I,y_stat]=dsearch(S,x,'d');
y_stat=y_stat/n;

y_th=distrib_binomiale(n0,p0)

clf;
subplot(121)
    bar(x,y_stat);
subplot(122)
    bar(x,y_th);
