rand('seed', getdate('s'))
rand('uniform')

function y=simul_geometrique(p)
  y=1;
  while (rand()>p)
    y=y+1;
  end
endfunction

function y=distrib_geometrique(p,n)
    y=p*(1-p).^(0:(n-1))
endfunction

N=10^4;     // nombre de simulations
n0=15;      // abscisse maximale pour le diagramme
p0=.25;     // choix du paramètre
x=1:n0;     // vecteur des valeurs possibles pour X

S=zeros(1,n);   // initiatlisation du vecteur des résultats des simulations
for k=1:N
  S(k)=simul_geometrique(p0);
end
[I,y_stat]=dsearch(S,x,'d');
y_stat=y_stat/n;

y_th=distrib_geometrique(p0,n0);

clf;
subplot(121)
    bar(x,y_stat);
subplot(122)
    bar(x,y_th);
