rand('seed', getdate('s'))
rand('uniform')

function y=simul_poisson(lambda)
    u=rand();
    y=0;
    p=exp(-lambda);
    F=p;
    while (u>F)
        // p=p(y) F=F(y)
        y=y+1;
        p=lambda/y*p;
        F=F+p;
    end
endfunction

function Y=simul_mult_poisson(n,lambda)
    // simule n variables aléatoires indépendantes de Poisson
    U=rand(1,n);
    Y=-ones(1,n);
    k=0;
    p=exp(-lambda);
    F=p;
    while (length(find(Y==-1))>0)
        Y(find((Y==-1)&(U<=F)))=k;
        k=k+1;
        p=p*lambda/k;
        F=F+p;
    end
endfunction

function y=distrib_poisson(lambda,n)
    y=exp(-lambda)*lambda.^(0:n)./[1,cumprod(1:n)]
endfunction

N=10^4;     // nombre de simulations
n0=20;      // abscisse maximale pour le diagramme
lambda0=5   // choix du paramètre
x=0:n0;     // vecteur des valeurs possibles pour X

S=simul_mult_poisson(N,lambda0);
[I,y_stat]=dsearch(S,x,'d');
y_stat=y_stat/N;

y_th=distrib_poisson(lambda0,n0);

clf;
subplot(121)
    bar(x,y_stat);
subplot(122)
    bar(x,y_th);
